"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const highlighter_1 = require("../highlighter");
/**
 * `graphql-logging` middleware
 * Based on this post: https://www.reddit.com/r/Strapi/comments/fzg4j6/comment/fn9eulv/
 */
exports.default = async (ctx, next) => {
    var _a;
    await next();
    // only log graphql post requests
    if (ctx.request.url === '/graphql' && ctx.request.method === 'POST') {
        const query = (_a = ctx.request.body) === null || _a === void 0 ? void 0 : _a.query;
        if (query) {
            // don't print huge introspection queries
            if (query.startsWith("query IntrospectionQuery ")) {
                console.log("Introspection query ignored");
            }
            else {
                // format response for better readability
                const resp = JSON.stringify(JSON.parse(ctx.body), null, "  ");
                // print highlighted query and response
                console.log(highlighter_1.Highlighter.highlight(query, "graphql"));
                console.log(highlighter_1.Highlighter.highlight(resp, "json"));
            }
        }
    }
};
